import { _tuple } from "./symbols";
import { Eny, RSE } from "./utils";
import { ReadonlyValit, Valit } from "./valit";
declare global {
    namespace vality {
        interface valits {
            array: <E extends Eny>(e: E) => Valit<E[], {
                minLength: number;
                maxLength: number;
                bail: boolean;
            }>;
            tuple: <E extends Eny[]>(...es: E) => Valit<E & {
                [_tuple]: true;
            }, {
                bail: boolean;
            }>;
            optional: <E extends Eny>(e: E) => Valit<undefined | E>;
            enum: <E extends Eny[]>(...es: E) => Valit<E[number]>;
            object: <E extends RSE>(v: E) => Valit<E, {
                bail: boolean;
            }>;
            readonly: <E extends Eny>(e: E) => ReadonlyValit<E>;
        }
    }
}
