import { _readonly } from "./symbols";
import { RSA, RSN, ValitParameters } from "./utils";
import type { Validate } from "./validate";
export declare type Valit<Type, Options extends RSA = RSN> = Validate<Type, Options, true>;
export declare type ValitOptions<Name extends keyof vality.valits, Fn = vality.valits[Name]> = Fn extends (...args: infer Args) => Valit<infer Type, infer Options> ? [Args, Type, Options] : never;
export declare type ReadonlyValit<T> = {
    [_readonly]?: true;
} & Valit<T>;
export declare function valit<Name extends keyof vality.valits, Arg extends ValitOptions<Name>[0], Type extends ValitOptions<Name>[1], Options extends RSA & ValitOptions<Name>[2]>(...[name, fn, handleOptions, defaultOptions]: ValitParameters<Name, Arg, Type, Options>): (...args: Arg) => Validate<Type, Options, true>;
